

   '
   ' EXAMPLE PROGRAM FOR DOMO - I
   '
   ' WATERING CONTROLLER FOR HOME GARDEN
   '
   ' (C) 1999 IBERCOMP SA - Writen by MIGUEL ZUIGA
   '
   $large

   Config Lcdpin , Db4 = P2.4 , Db5 = P2.5 , Db6 = P2.6 , Db7 = P2.7 , E = P2.1 , Rs = P2.2
   Config Sda = P1.0
   Config Scl = P1.1

   Config Watchdog = 128

   Dim State As Word                                          'Variable used as Subroutines parameters
   Dim Num As Byte
   Dim Value As Byte
   Dim Bol As Bit

   Declare Sub Outr (num As Byte , Bol As Bit)
   Declare Sub Qoutr (state As Word)
   Declare Sub Led (bol As Bit)
   Declare Sub Backlight (bol As Bit)

   Declare Sub Key
   Declare Sub Qino
   Declare Sub Ino (num As Byte)

   Declare Sub Gettime
   Declare Sub Settime

   Declare Sub Write_i2cram (num As Byte , Value As Byte)
   Declare Sub Read_i2cram (num As Byte)

   Declare Sub Lcdtime
   Declare Sub Lcddate
   Declare Sub Setuptime
   Declare Sub Lcdset
   Declare Sub Setupnum
   Declare Sub Setupdate

   Declare Sub Colaborate
   Declare Sub Setwatering

   Declare Sub Startwatering
   Declare Sub Abortwatering

   Declare Sub Lcddefault

   Dim Aux0 As Byte , Aux1 As Byte , Aux2 As Byte , Aux3 As Byte       'Used as general registers
   Dim Aux4 As Byte , Aux5 As Byte , Aux6 As Byte
   Dim Index As Byte                                          'Variable used as index (FOR .. NEXT, arrays, ...)

   Dim Seconds As Byte , Minutes As Byte , Hour As Byte , Day As Byte       'Real Time Registers
   Dim Date As Byte , Month As Byte , Year As Byte

   Dim Op As Byte                                             'Current option on Main Men
   Dim Zone As Byte                                           'Zone string (Share space with string S)
   Dim S As String * 17                                       'Used on lookup tables

   Dim Swait As Byte                                          'Ticks counter for next keyboard scan
   Dim Scan As Bit                                            'Indicate that a key is on buffer
   Dim Old As Byte , Scancode As Byte                         'Old key status and last scancode (buffer when scan=1)

   Dim Bltimer As Word                                        'Down counter for auto ESCape (Scancode = 16)

   Dim Divisor As Byte                                        'Increment on Timer 2 interrupt
   Dim Stanby As Bit                                          'Program is waiting for user
   Dim Esc As Bit                                             'ESC was pressend instead OK

   Dim Azone As Byte                                          'Active zone for watering
   Dim Rwt As Integer                                         'Remaining watering time
   Dim Oldm As Byte                                           'Old minutes
   Dim Water As Bit                                           'Flag that indicates watering process active
   Dim Manual As Bit                                          'Flag that indicate manual watering

   Dim Dscr As Bit                                            'Flag for default screen

Init:
   'Assembler code is needed because BASCOM do not handle R/-W line
   'for LCD, so this must be put manually to low before initialise
   'display.
   $asm
      MOV   C, P2.0
      CLR   P2.0
      JNC   continue
      LJMP  0
   Continue:
   $end Asm

   Waitms 500                                                 'Needed to prevent ISP accesing (ATMEL ISP Bug)

   Start Watchdog

   '
   ' Now I initialise PPI, PA are INPUTs, PB are OUTPUTs, PCL are OUTPUTS
   ' and PCH are INPUTs
   '
   $asm
      mov   R0, #3
      mov   A, #&H98
      movx  @R0, A

      mov   R0, #1
      mov   A, #&HFF
      movx  @R0, A

      mov   R0, #2
      mov   A, #&H0F
      movx  @R0, A

   $end Asm

   Goto Start

   '*************************************************************************
   '* B A S C O M    8 0 5 1    E X A M P L E    F O R    D O M O    -    I *                                *
   '*************************************************************************

   '
   ' Timer2 interrupt handler
   '
Ih_timer2:
   $asm
      mov   A, R0
      push  ACC        ;Save R0 used in KEY subrutine
      push  {num}      ;Save Num register used in KEY subrutine
            ; Mov C , {bol} ; Save Bit Bol
           ; Push Psw
   $end Asm

   Decr Divisor

   Key

   If Swait <> 0 Then                                         'If swait counter>0 then decrement one unit
      Swait = Swait - 1
   End If

   If Num <> 0 Then
      If Old <> Num Then
         Scan = 1                                             'A key was pushed
         Scancode = Num
         Old = Num
         Swait = 20                                           'Wait 20 for autorepeat
         Backlight 1
         Bltimer = 1000                                       'Backlight timer = 1000
      Elseif Swait = 0 Then
         Scan = 1                                             'A key was pushed
         Scancode = Num
         Old = Num
         Swait = 20                                           'Wait 20 for autorepeat
         Backlight 1
         Bltimer = 1000                                       'Backlight timer = 1000
      End If
   Elseif Swait < 15 Then
      Old = 0                                                 'Key was un pressed so
      Swait = 0                                               'liberate flags
   End If

   If Bltimer > 0 Then                                        'If Bltimer<>0 decrement, else
      Decr Bltimer                                            'LCD backlight off
   Else
      If Water = 1 Then                                       'During watering process LCD BACKLIGHT ON
         Backlight 1
      Elseif Manual = 1 Then
         Backlight 1
      Else
         Backlight 0
      End If

      Scan = 1
      Scancode = 16
      Old = 16
      Swait = 20
      Bltimer = 100                                           'Refresh ESC every 3 seconds
   End If


   'This routine can be improved adding a buffer for keys.

   $asm
        ; Pop Psw
        ; Mov {bol} , C
      pop   {num}
      pop   ACC
      mov   R0, A
   $end Asm

   Return                                                     'End of TIMER2 interrupt handler


Start:
   Cursor Off                                                 'Hide cursor

   Swait = 0                                                  'No wait for next keyboard scan
   Old = 0                                                    'No old scancode
   Scancode = 0                                               'No scancode
   Scan = 0                                                   'No scan
   Bltimer = 0                                                'Backlight off

   DSCR = 0                                                 'No default screen at start
   Water = 0                                                  'No watering in process
   Manual = 0                                                 'Also no manual watering in process

   Config Timer2 = Timer , Gate = Internal , Mode = 0         'Timer 2 inicialitation
   Start Timer2                                               'it is used to scan
   Load Timer2 , 50000                                        'DOMO - I keyboard
   On Timer2 Ih_timer2
   Enable Timer2
   Enable Interrupts

   Cls
   Locate 1 , 1
   Lcd "     "

   Op = 0
   Stanby = 1                                                 'At program start DOMO-I is waiting user


   Locate 2 , 1
   Lcd "DOMO-I  COMPUTER"

   Scan = 0
   Do
      Gettime                                                 'Read time
      Locate 1 , 3
      Lcdtime

      Colaborate

      If Scan = 1 Then
         'A key was pressed
         Select Case Scancode
            Case 1:
               If Stanby = 1 Then
                  Stanby = 0
               Else
                  Incr Op                                     'Print next option
                  If Op > 4 Then                              'There are only 0,1,2,3 and 4 options
                     Op = 0
                  End If
               End If
            Case 2:                                           'Select option
               If Stanby = 1 Then
                  Stanby = 0
               Else
                  Select Case Op
                     Case 0:                                  'Set time
                        Scan = 0
                        Setuptime
                     Case 1:                                  'Set date
                        Scan = 0
                        Setupdate
                     Case 2:                                  'Set WATERING PROGRAM
                        Scan = 0
                        Setwatering
                     Case 3:
                        Scan = 0
                        Startwatering
                     Case 4:
                        Scan = 0
                        Abortwatering

                  End Select
                  Cls
                  Lcd "     "
                  Scancode = 0
               End If
            Case 4:
               If Dscr = 1 Then
                  Dscr = 0
                  Locate 2 , 1
                  Lcddate
                  Stanby = 1
               Elseif Stanby = 1 Then                         'About option
                  Lcddefault
               Else
                  Locate 2 , 1
                  Lcddate
                  Stanby = 1                                  'Wait to user
               End If
            Case 16:
               Bltimer = 1                                    'Do not wait to generate a 16 again
               Lcddefault
               Stanby = 1                                     'Wait to user
         End Select

         If Scancode < 4 Then
            Waitms 1
            Locate 2 , 1
            Waitms 1
            S = Lookupstr(op , Options)
            Lcd S
            Aux0 = Len(s)
            For Aux1 = Aux0 To 16
               Lcd " "
            Next Aux1
         End If
         Scan = 0
      End If
   Loop

   Stop

   '
   ' Routine that works as colaborative "MULTITASKING"
   '
   Sub Colaborate
      'WDT NOTE: Here is a good place to refresh Watch Dog Timer
      Reset Watchdog

      If Water = 1 Then
         Aux0 = Divisor And 4
      Else
         Aux0 = Divisor And 16
      End If

      If Aux0 <> 0 Then                                       'Control LED switching
         Led 1
      Else
         Led 0
      End If

      If Water = 0 Then
         Qino                                                 'Read all inputs
         Aux0 = Num
         If Aux0 <> 0 Then
            For Aux1 = 0 To 7
               Ino Aux1
               Outr Aux1 , Bol
            Next Aux1
            Outr 8 , 1                                        'Motor ON
            Manual = 1                                        'Indicate manual watering
         Else
            Qoutr 0                                           'All zones and motor off
            Manual = 0                                        'Indicate that no manual watering requested
         End If
      End If

      push {seconds}                                          ;Save on stack real time registers
      push {minutes}
      push {hour}
      push {day}
      push {date}
      push {month}
      push {year}

      Gettime                                                 'Read current time

      Read_i2cram 8

      If Hour = Num Then                                      'If time=start time, then watering
         Read_i2cram 9
         If Minutes = Num Then
            Read_i2cram 10                                    'Test if current day is enabled
            Aux0 = 0
            Psw.7 = 1
            Rotate Aux0 , Left , Day
            Aux0 = Aux0 And Num
            If Aux0 <> 0 Then
               If Water = 0 Then
                  Water = 1                                   'Puts watering proces ON
                  Azone = 0                                   'Active Zone = 0 (Zone 0 do not exist)
                  Rwt = 0                                     'Remaining Watering Time = 0 minutes (change inmediatly)
                  Oldm = Seconds + 1                          'Force zone change
               End If
            End If
         End If
      End If

      If Water = 1 Then
         If Oldm <> Seconds Then                              'Has seconds change?
            While Rwt = 0                                     'Remainig time 0 for zone?
               Aux0 = Azone - 1
               If Azone > 0 Then
                  Outr Aux0 , 0                               'Desactivate prior zone
               End If

               If Azone < 8 Then
                  Outr 8 , 1                                  'Watering motor on
                  Outr Azone , 1                              'Activate Zone
                  Incr Azone                                  'Next zone

                  Aux0 = 10 + Azone                           'Read Zone timing
                  Read_i2cram Aux0
                  Rwt = Num * 60                              'Asign time for zone in seconds
               Else
                  Water = 0                                   'Watering is finish
                  Outr 8 , 0                                  'Pump Motor Off
                  Exit While
               End If
            Wend
            Decr Rwt                                          'Decrement remaining watering time
         End If
      End If


      Oldm = Seconds                                          'Save currently seconds

      pop   {year}                                            ;Recover from stack real time registers
      pop   {month}
      pop   {date}
      pop   {day}
      pop   {hour}
      pop   {minutes}
      pop   {seconds}
   End Sub

   '
   ' Routine that prints default screen
   '
   Sub Lcddefault

      Dscr = 1

      Locate 2 , 1
      If Water = 1 Then                                       'Print active zone
         Aux0 = Rwt / 60                                      'Calculate remainig time in minutes
         Aux0 = Aux0 + 1
         Aux0 = Makebcd(aux0)
         Lcd "ZONE:" ; Bcd(azone) ; "  TIME:" ; Bcd(aux0)
      Elseif Manual = 1 Then
         Lcd "MANUAL: "
         For Aux0 = 0 To 7
            Ino Aux0
            If Bol = 1 Then
               Aux1 = Aux0 + 1
               Lcd Aux1
            Else
               Lcd "_"
            End If
         Next Aux0
      Else
         Lcd "DOMO-I  COMPUTER"                               'Print presentation message
      End If
   End Sub

   '
   ' Routine that start unconditional watering process
   '
   Sub Startwatering
      Qoutr 0                                                 'All zones off

      Water = 1                                               'Puts watering proces ON
      Azone = 0                                               'Active Zone = 0 (Zone 0 do not exist)
      Rwt = 0                                                 'Remaining Watering Time = 0 minutes (change inmediatly)

      Locate 2 , 1
      Lcd "- WATERING  ON -"
   End Sub

   '
   'Routine that stop watering process
   '
   Sub Abortwatering
      Qoutr 0                                                 'All zones off
      Water = 0                                               'Indicate program that process stoped

      Locate 2 , 1
      Lcd "- WATERING OFF -"
   End Sub

   '
   ' Routine that prints time on LCD
   '
   Sub Lcdtime
      Decr Day
      If Day > 7 Then                                         'If day out range put XXX
         Day = 7
      End If
      S = Lookupstr(day , Weekdays)
      Lcd S ; ","
      Lcd Bcd(hour) ; ":" ; Bcd(minutes) ; ":" ; Bcd(seconds)
      Incr Day
   End Sub

   '
   ' Routine that prints date on LCD
   '
   Sub Lcddate
      Lcd "   " ; Bcd(date) ; "," ; Bcd(month) ; ","

      If Year > &H90 Then                                     'Year 2000?
         Lcd "19"
      Else
         Lcd "20"
      End If
      Lcd Bcd(year) ; "   "
   End Sub


   '
   ' Routine writes Real Time Clock
   '
   Sub Settime
      I2cstart
      I2cwbyte &HD0                                           'Slave address
      I2cwbyte 0                                              'First byte to write
      I2cwbyte Seconds
      I2cwbyte Minutes
      I2cwbyte Hour
      I2cwbyte Day
      I2cwbyte Date
      I2cwbyte Month
      I2cwbyte Year
      I2cstop
   End Sub

   '
   ' Routine that reads Real Time Clock
   '
   Sub Gettime
      I2cstart
      I2cwbyte &HD0
      I2cwbyte 0
      I2cstart
      I2cwbyte &HD1
      I2crbyte Seconds , Ack
      I2crbyte Minutes , Ack
      I2crbyte Hour , Ack
      I2crbyte Day , Ack
      I2crbyte Date , Ack
      I2crbyte Month , Ack
      I2crbyte Year , Nack
      I2cstop
   End Sub

   '
   ' Write I2C SRAM ( POKE num, value)
   '
   Sub Write_i2cram(num As Byte , Value As Byte)
      I2cstart
      I2cwbyte &HD0                                           'Slave address
      I2cwbyte Num                                            'First byte to write
      I2cwbyte Value
      I2cstop
   End Sub

   '
   ' Read I2C SRAM ( num = PEEK(num) )
   '
   Sub Read_i2cram(num As Byte)
      I2cstart
      I2cwbyte &HD0
      I2cwbyte Num
      I2cstart
      I2cwbyte &HD1
      I2crbyte Num , Nack
      I2cstop
   End Sub

   '
   'Primitive for Setupnum
   '
   Sub Lcdset
      Select Case Aux4
         Case 0:
            If Aux0 <> 0 Then
               Aux1 = Makebcd(aux1)                           'I want print number on two digits
               Lcd Bcd(aux1)
               Aux1 = Makedec(aux1)
            Else
               Lcd "  "
            End If
         Case 1:
            If Aux0 <> 0 Then
               If Aux1 = 1 Then
                  Decr Index
                  S = Lookupstr(index , Weekdays)
                  S = Mid(s , 1 , 1)
                  Lcd S
                  Incr Index
               Else
                  Lcd "_"
               End If
            Else
               Lcd " "
            End If
         Case 2:
            If Aux0 <> 0 Then
               S = Lookupstr(aux1 , Weekdays)
               Lcd S
            Else
               Lcd "   "
            End If
      End Select
   End Sub


   '
   ' Routine that lets user setup a number
   '
   Sub Setupnum
      Esc = 0
      Scan = 0

      Do
         Colaborate

         If Scan = 1 Then
            Select Case Scancode

            Case 1:                                           'Increment number
               Incr Aux1
               If Aux1 > Aux3 Then
                  Aux1 = 0
               End If
            Case 2:                                           'Number is OK
               Locate 2 , Aux2
               Aux0 = 1
               Lcdset
               Exit Do

            Case 4:                                           'ESC was pressed
               Esc = 1
               Exit Do

            Case 16:
               Esc = 1
               Exit Do

            End Select
            Scan = 0
         End If

         Locate 2 , Aux2

         Aux0 = Divisor And 16                                'Select blinking speed
         Aux0 = Aux0 + Swait

         Lcdset

      Loop
   End Sub


   '
   ' Routine that lets user setup time
   '
   Sub Setuptime
      Cls
      Lcd "       "

      Locate 1 , 1
      Lcd "-- SETUP TIME --"

      Gettime                                                 'Read time
      Locate 2 , 3
      Lcdtime

      Aux1 = Makedec(day) - 1
      Aux2 = 3
      Aux3 = 6
      Aux4 = 2
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Day = Makebcd(aux1) + 1

      Aux1 = Makedec(hour)
      Aux2 = 7
      Aux3 = 23
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Hour = Makebcd(aux1)

      Aux1 = Makedec(minutes)
      Aux2 = 10
      Aux3 = 59
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Minutes = Makebcd(aux1)

      Aux1 = Makedec(seconds)
      Aux2 = 13
      Aux3 = 59
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Seconds = Makebcd(aux1)


      Settime
   End Sub

   '
   ' Routine that lets user setup date
   '
   Sub Setupdate
      Cls
      Lcd "       "

      Locate 1 , 1
      Lcd "-- SETUP DATE --"

      Gettime                                                 'Read time
      Locate 2 , 1
      Lcddate

      Aux1 = Makedec(date)
      Aux2 = 4
      Aux3 = 31
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Date = Makebcd(aux1)

      Aux1 = Makedec(month)
      Aux2 = 7
      Aux3 = 12
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Month = Makebcd(aux1)

      Aux1 = Makedec(year)
      Aux2 = 12
      Aux3 = 99
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Year = Makebcd(aux1)


      Aux0 = Month                                            'Use AUX registers like a stack, better PUSH
      Aux1 = Year
      Aux2 = Date
      Gettime
      Date = Aux2
      Year = Aux1
      Month = Aux0
      Settime
   End Sub


   '
   ' Routine that let user to configure WATERING PROGRAM
   '
   Sub Setwatering
      Cls
      Lcd "       "

      Locate 1 , 1
      Lcd "- SET WATERING -"

      Locate 2 , 1
      Lcd "START TIME:"

      Read_i2cram 8
      Hour = Num
      Read_i2cram 9
      Minutes = Num
      Lcd Bcd(hour) ; ":" ; Bcd(minutes)

      Aux1 = Makedec(hour)
      Aux2 = 12
      Aux3 = 23
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Hour = Makebcd(aux1)

      Aux1 = Makedec(minutes)
      Aux2 = 15
      Aux3 = 59
      Aux4 = 0
      Setupnum
      If Esc = 1 Then Return                                  'ESC flag ON then exit settup
      Minutes = Makebcd(aux1)

      Locate 2 , 1
      Lcd "  DAYS:"

      Read_i2cram 10                                          'Reads days information
      Aux0 = Num
      For Index = 1 To 7
         Rotate Aux0 , Right
         If Psw.7 = 1 Then                                    'IF carry flag active a bit was ON
            Aux1 = Index - 1
            S = Lookupstr(aux1 , Weekdays)
            S = Mid(s , 1 , 1)
            Lcd S
         Else
            Lcd "_"
         End If
      Next Index
      Lcd "  "

      Read_i2cram 10
      Aux5 = Num
      For Index = 1 To 7
         Rotate Aux5 , Right
         Num = Psw.7

         Aux1 = Makedec(num)
         Aux2 = 7 + Index
         Aux3 = 1
         Aux4 = 1
         Setupnum
         If Esc = 1 Then
            Return                                            'ESC flag ON then exit settup
         End If
         Num = Makebcd(aux1)

         If Num <> 0 Then
            Psw.7 = 1
         Else
            Psw.7 = 0
         End If
         Rotate Aux6 , Right
      Next Index

      Psw.7 = 0
      Rotate Aux6 , Right

      For Index = 1 To 8
         Aux0 = 10 + Index                                    'Read Zone timing
         Read_i2cram Aux0

         Locate 2 , 1
         Lcd "ZONE " ; Index ; ":" ; Bcd(num) ; "       "

         Aux1 = Makedec(num)
         Aux2 = 8
         Aux3 = 99
         Aux4 = 0
         Setupnum
         If Esc = 1 Then Return                               'ESC flag ON then exit settup
         Num = Makebcd(aux1)

         $asm                                                 'Zone(index) = Num (I DO IN ASSEMBLER)
         Mov A , {index}
         Add A , #{zone}
         Mov R0 , A
         Mov A , {num}
         Mov @r0 , A
         $end Asm

      Next Index

      Write_i2cram 8 , Hour                                   'Save start watering hour
      Write_i2cram 9 , Minutes                                'Save start watering minutes
      Write_i2cram 10 , Aux6

      For Index = 1 To 8                                      'Save zone watering times
         Aux0 = 10 + Index

         $asm                                                 'aux1 = Zone(index) (I DO IN ASSEMBLER)
         Mov A , {index}
         Add A , #{zone}
         Mov R0 , A
         Mov A , @r0
         Mov {aux1} , A
         $end Asm

         Write_i2cram Aux0 , Aux1
      Next Index
   End Sub

   Weekdays:
      Data "Mon" , "Tue" , "Wen" , "Thu" , "Fri" , "Sat" , "Sun" , "???"

   Options:
      Data "SET TIME" , "SET DATE" , "SET WATERING" , "START WATERING" , "STOP WATERING"

   '*************************************************************************
   '* L O W    L E V E L    R O U T I N E S                                 *
   '*************************************************************************


   '
   'Out Rele - Define state off a ralay
   '
   Sub Outr (num As Byte , Bol As Bit)

   $asm
      mov   C, {bol}
      mov   A, {num}

        ; * * * * Parameters Acc Relay Number , Carry Ralay State

      mov   PSW.5, C
      cpl   PSW.5

      mov   R0, #2

      cjne A, #9, no_rel9 ;If relay 9 then PC.1
      mov   C, PSW.5
      movx  A, @R0
      mov   ACC.1, C
      movx  @R0, A
      sjmp  exit_outr
   No_rel9:

      cjne A, #8, no_rel8 ;If relay 8 then PC.0
      mov   C, PSW.5
      movx  A, @R0
      mov   ACC.0, C
      movx  @R0, A
      sjmp  exit_outr
   No_rel8:

      mov   B, A
      mov   A, #128           ;If relay 0 to 7 then PB
      inc   B
   Loop_outr:
      rl    A
      djnz  B, loop_outr

      dec   R0                ;Now R0 points to PB (R0=1)

      jnb   PSW.5, no_hight_state

      mov   B, A
      movx  A, @R0
      orl   A, B
      movx  @R0, A
      sjmp  exit_outr

   No_hight_state:
      cpl   A
      mov   B, A
      movx  A, @R0
      anl   A, B
      movx  @R0, A
   Exit_outr:

   $end Asm

   End Sub

   '
   'Quick Out Rele - Define state of all relays
   '
   Sub Qoutr (state As Word)

   $asm
      mov   A, {state}     ;LSB
      mov   B, {state+1}   ;MSB

        ; * * * * Parameter Acc Low Byte , B Hight Byte


      mov   R0, #1         ;LSB to PB
      cpl   A
      movx  @R0, A

      mov   A, B           ;MSB to PC.1 and PC.0
      cpl   A
      anl   A, #3
      mov   B, A
      mov   R0, #2
      movx  A, @R0
      anl   A, #&HFC
      orl   A, B
      movx  @R0, A

   $end Asm

   End Sub

   '
   'Define LED state
   '
   Sub Led (bol As Bit)
   $asm
      mov   C, {bol}       ;bol to PC.3

        ; * * * * Parameter On Carry Bit

      cpl   C
      mov   R0, #2
      movx  A, @R0
      mov   ACC.3, C
      movx  @R0, A
   $end Asm
   End Sub

   '
   'Define LCD backlight state
   '
   Sub Backlight (bol As Bit)
   $asm
      mov   C, {bol}      ;bol to PC.2

        ; * * * * Parameter On Carry Bit

      cpl   C
      mov   R0, #2
      movx  A, @R0
      mov   ACC.2, C
      movx  @R0, A
   $end Asm
   End Sub

   '
   'Returns on num variable value of ROW key
   '
   Sub Key
      $asm
      mov   R0, #2        ;Reads hight nibble from PC register
      movx  A, @R0
      Swap A
      cpl   A
      anl   A, #15

        ; * * * * Return Value Acc

      mov   {num}, A
      $end Asm
   End Sub

   '
   'Returns on num variable Inputs state
   '
   Sub Qino
      $asm
      mov   R0, #0        ;Reads PA register
      movx  A, @R0
      cpl   A

        ; * * * * Return Value Acc

      mov   {num}, A
      $end Asm
   End Sub

   '
   'Returns on bol the state of input num
   '
   Sub Ino
      $asm
         mov   A, {num}

          ; * * * * Parameter Acc Number Of Input

         anl   A, #7      ;Only 8 posible inputs
         mov   B, A

         mov   R0, #0     ;Reads PA register
         movx  A, @R0

         inc   B
      Shift:
         rrc   A
         djnz  B, shift

         cpl   C

          ; * * * * Return Parameter Carry = Input State

         mov   {bol}, C
      $end Asm
   End Sub